"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HttpServiceHandle = /** @class */ (function () {
    function HttpServiceHandle(config) {
        this.types = {
            prepare: '',
            success: '',
            fail: '',
        };
        this.config = config;
    }
    HttpServiceHandle.prototype.query = function (query) {
        this.config.query = query;
        return this;
    };
    HttpServiceHandle.prototype.body = function (body) {
        this.config.body = body;
        return this;
    };
    HttpServiceHandle.prototype.successText = function (text) {
        this.config.successText = text;
        return this;
    };
    HttpServiceHandle.prototype.failText = function (text) {
        this.config.failText = text;
        return this;
    };
    HttpServiceHandle.prototype.requestOptions = function (options) {
        this.config.requestOptions = options;
        return this;
    };
    HttpServiceHandle.prototype.hideError = function (is) {
        this.config.hideError = is;
        return this;
    };
    HttpServiceHandle.prototype.payload = function (payload) {
        this.config.payload = payload;
        // @ts-ignore
        return this;
    };
    HttpServiceHandle.prototype.withMeta = function (param) {
        this.config.metaKey = param;
        return this;
    };
    ;
    HttpServiceHandle.prototype.onPrepare = function (fn) {
        this.config.onPrepare = fn;
        return this;
    };
    HttpServiceHandle.prototype.onSuccess = function (fn) {
        this.config.onSuccess = fn;
        return this;
    };
    HttpServiceHandle.prototype.onFail = function (fn) {
        this.config.onFail = fn;
        return this;
    };
    HttpServiceHandle.prototype.collect = function (types) {
        var config = this.config;
        var action = {
            uri: config.uri,
            type: types,
            method: config.method,
            reducerName: config.instanceName,
            payload: config.payload === undefined ? {} : config.payload,
            body: config.body || {},
            query: config.query || {},
            successText: config.successText || '',
            failText: config.failText || '',
            hideError: config.hideError || false,
            requestOptions: config.requestOptions || {},
            metaKey: config.metaKey === undefined ? true : config.metaKey,
            onPrepare: config.onPrepare || null,
            onSuccess: config.onSuccess || null,
            onFail: config.onFail || null,
        };
        return action;
    };
    return HttpServiceHandle;
}());
exports.HttpServiceHandle = HttpServiceHandle;
