"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var method_1 = require("../utils/method");
var OrphanHttpServiceHandle = /** @class */ (function () {
    function OrphanHttpServiceHandle(config, fetchApi) {
        this.method = method_1.METHOD.get;
        this.config = config;
        this.fetchApi = fetchApi;
    }
    OrphanHttpServiceHandle.prototype.setMethod = function (method) {
        this.method = method;
        return this;
    };
    OrphanHttpServiceHandle.prototype.runAction = function () {
        var config = this.config;
        var action = {
            body: config.body || {},
            query: config.query || {},
            successText: '',
            failText: '',
            hideError: true,
            requestOptions: config.requestOptions || {},
            uri: config.uri,
            type: {
                prepare: '',
                success: '',
                fail: '',
            },
            method: this.method,
        };
        // @ts-ignore
        return this.fetchApi.runAction(action);
    };
    return OrphanHttpServiceHandle;
}());
exports.OrphanHttpServiceHandle = OrphanHttpServiceHandle;
